#include <stdio.h>
#include <math.h>
#include "vec.h"
Vec_ptr P[3];

#include "new.c"
#include "nfvec.c"

main()

{ char Ans;
  P[0]=Vec_open(8); P[1]=Vec_open(8); P[2]=Vec_open(8);
  printf("\nTEST SCALAR AND VECTOR ROUTINES");
  Ans='0';
  while (Ans!='Z' && Ans!='z')
  { printf("\n");
    printf("1)            2)            3) Vec_open   4) Vec_close\n");
    printf("5) Vec_init   6) Put_val    7) Vec_move   8) Vec_chs\n");
    printf("9) Vec_conj   a) Vec_add    b) Vec_sadd   c) Vec_sub\n");
    printf("d) Vec_ssub   e) Vec_mult   f) Vec_smult  g) Vec_div\n");
    printf("h) Vec_sdiv   i) Vec_sum    j) Vec_dot    k) Vec_sqrt\n");
    printf("l) Vec_exp    m) Vec_ln     n) Vec_sin    o) Vec_cos\n");
    printf("p) Arc_sin    q) Arc_cos    r) Vec_tan    s) Arc_tan\n");
    printf("t) Vec_fft    u) Vec_ifft   v) Vec_acc\n");
    printf("Z) Quit\n");
    printf(" = ");
    while ( (Ans=getchar())<'0');
    printf("\n");
    switch(Ans)
    { case '1':      ; break;   case '2':      ; break; 
      case '3':XOpen(); break;  case '4':XClose(); break; 
      case '5':XInit(); break;  case '6':XPut(); break;
      case '7':XMove(); break;  case '8':XChs(); break; 
      case '9':XConj(); break;  case 'a':XAdd(); break;
      case 'b':XSadd(); break;  case 'c':XSub(); break; 
      case 'd':XSsub(); break;  case 'e':XMult(); break;
      case 'f':XSmult(); break; case 'g':XDiv(); break; 
      case 'h':XSdiv(); break;  case 'i':XSum(); break;
      case 'j':XDot(); break;   case 'k':XSqrt(); break; 
      case 'l':XExp(); break;   case 'm':XLn(); break;
      case 'n':XSin(); break;   case 'o':XCos(); break; 
      case 'p':XAsin(); break;  case 'q':XAcos(); break;
      case 'r':XTan(); break;   case 's':XAtan(); break; 
      /*case 't':XFft(); break;   case 'u':XIfft(); break;
      case 'v':Xvacc(); break; */
    } /*switch*/
    if (Ans!='Z') Vec_display();
  } /*while*/
} /*main*/

#include "vec.c"
#include "vecmove.c"
#include "vecchs.c"
#include "vecconj.c"
#include "vecadd.c"
#include "vecsadd.c"
#include "vecsub.c"
#include "vecssub.c"
#include "vecmult.c"
#include "vecsmult.c"
#include "vecdiv.c"
#include "vecsdiv.c"
#include "vecsum.c"
#include "vecdot.c"
#include "vecsqrt.c"
#include "vecexp.c"
#include "vecln.c"
#include "vecsin.c"
#include "veccos.c"
#include "vectan.c"
#include "vecasin.c"
#include "vecacos.c"
#include "vecatan.c"

/*
{$I Vecfft.pas}
*/

Vec_info_stat()
{ int i;
  printf("\n");
  for (i=0; i<3; i++)
  { if (P[i]==NULL) printf("P%d=NULL, P%d->Re=NULL, P%d->Im=NULL",i,i,i);
    else 
    { printf("(%4d)  ",P[i]->Length);
      if (P[i]->Re==NULL) printf("P%d->Re=NULL, ",i);
      else printf("             ");
      if (P[i]->Im==NULL) printf("P%d->Im=NULL",i);
    } /*else*/
    printf("\n");
  } /*for*/
} /*Vec_info_stat*/

Vec_display()
{ int i,j;
  printf("\n");
  printf("%9s%9s%9s%9s%9s%9s\n","Re(P0)","Im(P0)","Re(P1)","Im(P1)",
 	"Re(P2)","Im(P2)");
  for (i=0; i<10; i++) 
  { for (j=0; j<3; j++) if (P[j]!=NULL) 
    { if (P[j]->Re!=NULL) printf("%8.4g ",Vec_get_re(i,P[j]));
      else printf("%9s"," ");
      if (P[j]->Im!=NULL) printf("%8.4g ",Vec_get_im(i,P[j]));
      else printf("%9s"," ");
    }
    else printf("%18s"," ");
    printf("\n");
  } /*for*/
} /*Vec_display*/

XOpen()
{int Length,Ivec;
 Vec_info_stat();
 printf("Which vector to open (0-2, -1 to quit) = ");
 scanf("%d",&Ivec);
 printf("Length of vector = ");
 scanf("%d",&Length);
 if (Ivec>=0 && Ivec<3) P[Ivec]=Vec_open(Length);
 Vec_info_stat();
} /*XOpen*/

XClose()
{int Ivec;
 Vec_info_stat();
 printf("Which vector to close(0-2, -1 to quit) = ");
 scanf("%d",&Ivec);
 if (Ivec>=0 && Ivec<3) P[Ivec] = Vec_close(P[Ivec]);
 Vec_info_stat();
}

XPut()
{ int Ivec,Index;  Rtyp Re,Im;  char Ans;
  printf("Which vector for put (0-2, -1 to quit) = ");
  scanf("%d",&Ivec);
  if (Ivec<0 || Ivec>2) return(0);
  Vec_info_stat();
  printf("(R)eal, (I)maginary or (B)oth = ");  while( (Ans=getchar())<'0' );
  printf("Index = ");  scanf("%d",&Index);
  if (Ans=='R' || Ans=='r')
  { printf("Input real part = ");  scanf("%lf",&Re); 
    Vec_put_re(Index,Re,P[Ivec]);
  }
  if (Ans=='I' || Ans=='i')
  { printf("Input imaginary part = ");  scanf("%lf",&Im);
    Vec_put_im(Index,Im,P[Ivec]);
  }
  if (Ans=='B' || Ans=='b')
  { printf("Input real and imaginary = ");  scanf("%lf %lf",&Re,&Im);
    Vec_put(Index,Re,Im,P[Ivec]);
  }
  Vec_info_stat();
}  /*XPut*/

XInit()
{ int Ivec;  Rtyp Re,Im;  char Ans;
  printf("Which vector to initialize (0-2, -1 to quit) = ");
  scanf("%d",&Ivec);
  if (Ivec<0 || Ivec>2) return(0);
  Vec_info_stat();
  printf("(R)eal, (I)maginary or (B)oth = ");  while( (Ans=getchar())<'0' ); 
  if (Ans=='R' || Ans=='r')
  { printf("Input real part = ");  scanf("%lf",&Re);  
    Vec_init_re(Re,P[Ivec]);
  }
  if (Ans=='I' || Ans=='i')
  { printf("Input imaginary part = ");  scanf("%lf",&Im);
    Vec_init_im(Im,P[Ivec]);
  }
  if (Ans=='B' || Ans=='b')
  { printf("Input real and imaginary = ");  scanf("%lf %lf",&Re,&Im);
    Vec_init(Re,Im,P[Ivec]);
  }
  Vec_info_stat();
}  /*XPut*/

XMove()
{ int Ivec1,Ivec2; char Ans;
  printf("Move from, to (0-2, -1 to quit) = ");
  scanf("%d%d",&Ivec1,&Ivec2);
  if (Ivec1<0 || Ivec1>2 || Ivec2<0 || Ivec2>2 ) return(0);
  printf("(R)eal, (I)maginary or (B)oth = ");  while( (Ans=getchar())<'0' ); 
  if (Ans=='R' || Ans=='r') Vec_move_re(P[Ivec1],P[Ivec2]);
  if (Ans=='I' || Ans=='i') Vec_move_im(P[Ivec1],P[Ivec2]);
  if (Ans=='B' || Ans=='b') Vec_move(P[Ivec1],P[Ivec2]);
  Vec_info_stat();
}  /*XMove*/

XChs()
{ int I1,I2;
  printf("Change sign, from, to (0-2, -1 to quit) = ");
  scanf("%d %d",&I1,&I2);
  if (I1<0 || I1>2 || I2<0 || I2>2 ) return(0);
  Vec_chs(P[I1],P[I2]);
}  /*XChs*/

XConj()
{ int I1,I2;
  printf("Conjugate, from, to (0-2, -1 to quit) = ");
  scanf("%d %d",&I1,&I2);
  if (I1<0 || I1>2 || I2<0 || I2>2 ) return(0);
  Vec_conj(P[I1],P[I2]);
}  /*XConj*/

XAdd()
{int I1,I2,I3;
 printf("Two to add and result (0-2, -1 to quit) = ");
 scanf("%d %d %d",&I1,&I2,&I3);
 if (I1>=0 && I2>=0 && I3>=0 && I1<3 && I2<3 && I3<3) Vec_add(P[I1],P[I2],P[I3]);
} /*XAdd*/

XSadd()
{int I2,I3; Rtyp Re,Im;
 printf("Re and Im to add = ");
 scanf("%lf %lf",&Re,&Im);
 printf("Vector to add to and result (0-2, -1 to quit) = ");
 scanf("%d %d",&I2,&I3);
 if (I2>=0 && I3>=0 && I2<3 && I3<3) Vec_sadd(Re,Im,P[I2],P[I3]);
} /*XSadd*/

XSub()
{int I1,I2,I3;
 printf("Two to sub and result (0-2, -1 to quit) = ");
 scanf("%d %d %d",&I1,&I2,&I3);
 if (I1>=0 && I2>=0 && I3>=0 && I1<3 && I2<3 && I3<3) Vec_sub(P[I1],P[I2],P[I3]);
} /*XSub*/

XSsub()
{int I2,I3; Rtyp Re,Im;
 printf("Re and Im to sub = ");
 scanf("%lf %lf",&Re,&Im);
 printf("Vector to sub to and result (0-2, -1 to quit) = ");
 scanf("%d %d",&I2,&I3);
 if (I2>=0 && I3>=0 && I2<3 && I3<3) Vec_ssub(Re,Im,P[I2],P[I3]);
} /*XSsub*/

XMult()
{int I1,I2,I3;
 printf("Two to mult and result (0-2, -1 to quit) = ");
 scanf("%d %d %d",&I1,&I2,&I3);
 if (I1>=0 && I2>=0 && I3>=0 && I1<3 && I2<3 && I3<3) Vec_mult(P[I1],P[I2],P[I3]);
} /*XMult*/

XSmult()
{int I2,I3; Rtyp Re,Im;
 printf("Re and Im to mult = ");
 scanf("%lf %lf",&Re,&Im);
 printf("Vector to mult to and result (0-2, -1 to quit) = ");
 scanf("%d %d",&I2,&I3);
 if (I2>=0 && I3>=0 && I2<3 && I3<3) Vec_smult(Re,Im,P[I2],P[I3]);
} /*XSmult*/

XDiv()
{int I1,I2,I3;
 printf("Two to div and result (0-2, -1 to quit) = ");
 scanf("%d %d %d",&I1,&I2,&I3);
 if (I1>=0 && I2>=0 && I3>=0 && I1<3 && I2<3 && I3<3) Vec_div(P[I1],P[I2],P[I3]);
} /*XDiv*/

XSdiv()
{int I2,I3; Rtyp Re,Im;
 printf("Re and Im to div = ");
 scanf("%lf %lf",&Re,&Im);
 printf("Vector to div to and result (0-2, -1 to quit) = ");
 scanf("%d %d",&I2,&I3);
 if (I2>=0 && I3>=0 && I2<3 && I3<3) Vec_sdiv(Re,Im,P[I2],P[I3]);
} /*XSdiv*/

XSum()
{ int I1;  Rtyp Re,Im;
  printf("Which vector for sum = ");
  scanf("%d",&I1);
  if (I1>=0 && I1<3) Vec_sum(P[I1],&Re,&Im);
  printf("\nSum = %8f %8f\n",Re,Im);
} /*XSum*/

XDot()
{ int I1,I2;  Rtyp Re,Im;
  printf("Which vector for dot = ");
  scanf("%d %d",&I1,&I2);
  if (I1>=0 && I1<3 && I2>=0 && I2<3) Vec_dot(P[I1],P[I2],&Re,&Im);
  printf("\nDot = %8f %8f\n",Re,Im);
} /*XDot*/

XSqrt()
{ int I1,I2;
  printf("Which vector for sqrt = ");
  scanf("%d %d",&I1,&I2);
  if (I1>=0 && I1<3 && I2>=0 && I2<3) Vec_sqrt(P[I1],P[I2]);
} /*XSqrt*/

XExp()
{ int I1,I2;
  printf("Which vector for exp = ");
  scanf("%d %d",&I1,&I2);
  if (I1>=0 && I1<3 && I2>=0 && I2<3) Vec_exp(P[I1],P[I2]);
} /*XExp*/

XLn()
{ int I1,I2;
  printf("Which vector for ln = ");
  scanf("%d %d",&I1,&I2);
  if (I1>=0 && I1<3 && I2>=0 && I2<3) Vec_ln(P[I1],P[I2]);
} /*Xln*/

XSin()
{ int I1,I2;
  printf("Which vector for sin = ");
  scanf("%d %d",&I1,&I2);
  if (I1>=0 && I1<3 && I2>=0 && I2<3) Vec_sin(P[I1],P[I2]);
} /*XSin*/

XCos()
{ int I1,I2;
  printf("Which vector for cos = ");
  scanf("%d %d",&I1,&I2);
  if (I1>=0 && I1<3 && I2>=0 && I2<3) Vec_cos(P[I1],P[I2]);
} /*XCos*/

XTan()
{ int I1,I2;
  printf("Which vector for tan = ");
  scanf("%d %d",&I1,&I2);
  if (I1>=0 && I1<3 && I2>=0 && I2<3) Vec_tan(P[I1],P[I2]);
} /*XTan*/

XAsin()
{ int I1,I2;
  printf("Which vector for asin = ");
  scanf("%d %d",&I1,&I2);
  if (I1>=0 && I1<3 && I2>=0 && I2<3) Vec_asin(P[I1],P[I2]);
} /*XAsin*/

XAcos()
{ int I1,I2;
  printf("Which vector for acos = ");
  scanf("%d %d",&I1,&I2);
  if (I1>=0 && I1<3 && I2>=0 && I2<3) Vec_acos(P[I1],P[I2]);
} /*XAcos*/

XAtan()
{ int I1,I2;
  printf("Which vector for atan = ");
  scanf("%d %d",&I1,&I2);
  if (I1>=0 && I1<3 && I2>=0 && I2<3) Vec_atan(P[I1],P[I2]);
} /*XAtan*/

/*

  PROCEDURE XFft;
    VAR
      I1 : INTEGER;
    BEGIN
      WRITE('Which vector for FFT (1-3) = ');
      READLN(I1);
      IF I1 IN [1..3] THEN Vec_fft(P[I1])
    END; {XFft}

  PROCEDURE XIfft;
    VAR
      I1 : INTEGER;
    BEGIN
      WRITE('Which vector for inverse FFT (1-3) = ');
      READLN(I1);
      IF I1 IN [1..3] THEN Vec_ifft(P[I1])
    END; {XIfft}
*/


